<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: polyhedron.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>polyhedron.h</h1><a href="polyhedron_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 
<a name="l00018"></a>00018 <span class="preprocessor">#ifndef _polyhedron_H_</span>
<a name="l00019"></a>00019 <span class="preprocessor"></span><span class="preprocessor">#define _polyhedron_H_</span>
<a name="l00020"></a>00020 <span class="preprocessor"></span>
<a name="l00021"></a>00021 <span class="comment">/* Make sure the Constraint member is valid */</span>
<a name="l00022"></a><a class="code" href="polyhedron_8h.html#a54a764faf683e794f4db092c8d050104">00022</a> <span class="preprocessor">#define POL_ENSURE_INEQUALITIES(P)                                              \</span>
<a name="l00023"></a>00023 <span class="preprocessor">        if (F_ISSET(P, POL_VALID) &amp;&amp; !F_ISSET(P, POL_INEQUALITIES))             \</span>
<a name="l00024"></a>00024 <span class="preprocessor">            Polyhedron_Compute_Dual(P);</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="comment">/* Make sure the Ray member is valid */</span>
<a name="l00026"></a><a class="code" href="polyhedron_8h.html#a6dd85019d042c483105a927e7babfdfa">00026</a> <span class="preprocessor">#define POL_ENSURE_POINTS(P)                                                    \</span>
<a name="l00027"></a>00027 <span class="preprocessor">        if (F_ISSET(P, POL_VALID) &amp;&amp; !F_ISSET(P, POL_POINTS))                   \</span>
<a name="l00028"></a>00028 <span class="preprocessor">            Polyhedron_Compute_Dual(P);</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="comment">/* Make sure the Constraint member is valid and non-redundant */</span>
<a name="l00030"></a><a class="code" href="polyhedron_8h.html#a729f721c450a034c1219447745c6b123">00030</a> <span class="preprocessor">#define POL_ENSURE_FACETS(P)                                                    \</span>
<a name="l00031"></a>00031 <span class="preprocessor">        if (F_ISSET(P, POL_VALID) &amp;&amp; !F_ISSET(P, POL_FACETS))                   \</span>
<a name="l00032"></a>00032 <span class="preprocessor">            Polyhedron_Compute_Dual(P);</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="comment">/* Make sure the Ray member is valid and non-redundant */</span>
<a name="l00034"></a><a class="code" href="polyhedron_8h.html#a317e5eb888f5c14e1229742f31169378">00034</a> <span class="preprocessor">#define POL_ENSURE_VERTICES(P)                                                  \</span>
<a name="l00035"></a>00035 <span class="preprocessor">        if (F_ISSET(P, POL_VALID) &amp;&amp; !F_ISSET(P, POL_VERTICES))                 \</span>
<a name="l00036"></a>00036 <span class="preprocessor">            Polyhedron_Compute_Dual(P);</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="preprocessor">#if defined(__cplusplus)</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00040"></a>00040 <span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="polyhedron_8c.html#a4e3db79bcd2da3284175f960012af17a">Polyhedron_Compute_Dual</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *P);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a5ec487b5417647317b8e71f93b09c59e">DomainConstraintSimplify</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *P, <span class="keywordtype">unsigned</span> MaxRays);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a9690baafb863abbd2e8d5c4da2995416">AddConstraints</a>(Value *Con,<span class="keywordtype">unsigned</span> NbConstraints,
<a name="l00047"></a>00047                                    <a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<span class="keywordtype">unsigned</span> NbMaxRays );
<a name="l00048"></a>00048 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a965fd466bed4b1dd143c426e51ac16c5">AddPolyToDomain</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<a class="code" href="structpolyhedron.html">Polyhedron</a> *PolDomain);
<a name="l00049"></a>00049 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a964e678fe2d07dd6162a7f1c429d38ba">AddRays</a> (Value *Ray2,<span class="keywordtype">unsigned</span> NbRay2,<a class="code" href="structpolyhedron.html">Polyhedron</a>
<a name="l00050"></a>00050                             *Pol1,<span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00051"></a>00051 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#affd77db2a2f748d557ab6be0fcede209">align_context</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<span class="keywordtype">int</span> align_dimension,
<a name="l00052"></a>00052                                   <span class="keywordtype">int</span> NbMaxRays);
<a name="l00053"></a>00053 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#aefb77665a187d751bdd44f106b12465e" title="Given a matrix of constraints (&amp;#39;Constraints&amp;#39;), construct and return a polyhedron...">Constraints2Polyhedron</a>(<a class="code" href="structmatrix.html">Matrix</a> *Constraints, <span class="keywordtype">unsigned</span>
<a name="l00054"></a>00054                                           NbMaxRays);
<a name="l00055"></a>00055 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#aa2db71a574d8c1b1c3d90df140f1e5fd">Disjoint_Domain</a>( <a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol, <span class="keywordtype">int</span> flag, <span class="keywordtype">unsigned</span>
<a name="l00056"></a>00056                NbMaxRays );
<a name="l00057"></a>00057 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#afa3e85ca5d8849370db166c2ea6851c6">DomainAddConstraints</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<a class="code" href="structmatrix.html">Matrix</a> *Mat,
<a name="l00058"></a>00058                                         <span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00059"></a>00059 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a5ac0337f8a955ee77d5414761f3d41bb">DomainAddRays</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<a class="code" href="structmatrix.html">Matrix</a> *Ray,
<a name="l00060"></a>00060                                  <span class="keywordtype">unsigned</span> NbMaxConstrs);
<a name="l00061"></a>00061 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a53b04dfca9570691fbe42574118215ab">DomainConvex</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<span class="keywordtype">unsigned</span> NbMaxConstrs);
<a name="l00062"></a>00062 <span class="keyword">extern</span> <a class="code" href="structinterval.html">Interval</a> *<a class="code" href="polyhedron_8c.html#a99cc84955162014f9ca1805281bc8c04">DomainCost</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,Value *Cost);
<a name="l00063"></a>00063 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#aaaefa8685a2b2819b9863f2e4ff427f5">DomainDifference</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol1,<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol2,
<a name="l00064"></a>00064                                     <span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00065"></a>00065 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a8b92d94a0a1cbd47b98e9f72f34c43eb">DomainImage</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<a class="code" href="structmatrix.html">Matrix</a> *Func,<span class="keywordtype">unsigned</span>
<a name="l00066"></a>00066                                NbMaxConstrs);
<a name="l00067"></a>00067 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#ac5a1a2751f0b833183560af25b18033b">DomainIntersection</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol1,<a class="code" href="structpolyhedron.html">Polyhedron</a>
<a name="l00068"></a>00068                                       *Pol2, <span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00069"></a>00069 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a494ede0f23752164d1c839085a0e3be2">DomainPreimage</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<a class="code" href="structmatrix.html">Matrix</a> *Func,
<a name="l00070"></a>00070                                   <span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00071"></a>00071 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a5fe8c61eb1dddc73783aad88c76ce758">DomainSimplify</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol1, <a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol2,
<a name="l00072"></a>00072                                   <span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00073"></a>00073 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a95a584b74e1fa94e39740fc4c4cf1bdb">Stras_DomainSimplify</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol1, <a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol2,
<a name="l00074"></a>00074                                         <span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00075"></a>00075 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a6e402792ade8ef5e83a87d623f03c5cb">DomainUnion</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol1,<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol2,
<a name="l00076"></a>00076                                <span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00077"></a>00077 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#ad57e191f32f3c9022ec00747f4908b3f">Domain_Copy</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00078"></a>00078 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="polyhedron_8c.html#ae6d0a7daf8e801a777fc8e93d8cfe43a">Domain_Free</a> (<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00079"></a>00079 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="polyhedron_8c.html#a1d8ad597537b66ac5c09e3c231002a7c">Domain_PrintConstraints</a>(FILE *Dst, <span class="keyword">const</span> <span class="keywordtype">char</span> *Format,
<a name="l00080"></a>00080                                     <a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00081"></a>00081 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a37f19f6863a633aa08657cadf564d3d6">Empty_Polyhedron</a>(<span class="keywordtype">unsigned</span> Dimension);
<a name="l00082"></a>00082 <span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="polyhedron_8c.html#a671d2a19d0c376dec383521e78faa70a">Gauss</a>(<a class="code" href="structmatrix.html">Matrix</a> *Mat,<span class="keywordtype">int</span> NbEq,<span class="keywordtype">int</span> Dimension);
<a name="l00083"></a>00083 <span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="polyhedron_8c.html#aa8c3f429dd74c5ec2087f97d702cdc66">lower_upper_bounds</a>(<span class="keywordtype">int</span> pos,<a class="code" href="structpolyhedron.html">Polyhedron</a> *P,Value *context,
<a name="l00084"></a>00084                               Value *LBp,Value *UBp);
<a name="l00085"></a>00085 <span class="keyword">extern</span> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="polyhedron_8c.html#a69417a994cd682d0c391ecff6d223cd2">Polyhedron2Constraints</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00086"></a>00086 <span class="keyword">extern</span> <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="polyhedron_8c.html#a4163ba86faa8741d9215ff038a791bda">Polyhedron2Rays</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00087"></a>00087 <span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="polyhedron_8c.html#a107a96d44465428ffcd25f1ab3d67b43">PolyhedronIncludes</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol1,<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol2);
<a name="l00088"></a>00088 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a>* <a class="code" href="polyhedron_8c.html#aa308ade6448cc5544e21d59e86a53ddf">Polyhedron_Alloc</a>(<span class="keywordtype">unsigned</span> Dimension,<span class="keywordtype">unsigned</span>
<a name="l00089"></a>00089                                     NbConstraints,<span class="keywordtype">unsigned</span> NbRays);
<a name="l00090"></a>00090 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#ab0f89a51f01cea6b93b8fb3ab43feca3">Polyhedron_Copy</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00091"></a>00091 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="polyhedron_8c.html#a4ae97b9794e3a616f1d38c68e6515cc3">Polyhedron_Free</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00092"></a>00092 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a0b1d25597364fcc0847e8de25d9454c4">Polyhedron_Image</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<a class="code" href="structmatrix.html">Matrix</a> *Func,
<a name="l00093"></a>00093                                     <span class="keywordtype">unsigned</span> NbMaxConstrs);
<a name="l00094"></a>00094 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a53d52d5d1befc1d1446e0920556c3d24">Polyhedron_Preimage</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,<a class="code" href="structmatrix.html">Matrix</a> *Func,
<a name="l00095"></a>00095                                        <span class="keywordtype">unsigned</span> NbMaxRays);
<a name="l00096"></a>00096 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="polyhedron_8c.html#ad87595bd01c5cdd0f3933824943db496">Polyhedron_Print</a>(FILE *Dst, <span class="keyword">const</span> <span class="keywordtype">char</span> *Format, <span class="keyword">const</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00097"></a>00097 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="polyhedron_8c.html#a2303f014f8cd948a950c920085135081">Polyhedron_PrintConstraints</a>(FILE *Dst, <span class="keyword">const</span> <span class="keywordtype">char</span> *Format,
<a name="l00098"></a>00098                 <a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00099"></a>00099 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a7e6c09758e3d3063be1386c7026b38ba">Polyhedron_Scan</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *D,<a class="code" href="structpolyhedron.html">Polyhedron</a> *C,
<a name="l00100"></a>00100                                    <span class="keywordtype">unsigned</span> <a class="code" href="verif__ehrhart_8c.html#a89fd83aa168651629c012d8655635588">MAXRAYS</a>);
<a name="l00101"></a>00101 <span class="keyword">extern</span> <span class="keywordtype">void</span> <a class="code" href="polyhedron_8c.html#a09e380e70f4f88c4a646b4795f9c9626">PolyPrint</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol);
<a name="l00102"></a>00102 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a3d5b12b71133d329c88db195b56d9feb" title="Given a matrix of rays &amp;#39;Ray&amp;#39;, create and return a polyhedron.">Rays2Polyhedron</a>(<a class="code" href="structmatrix.html">Matrix</a> *Ray,<span class="keywordtype">unsigned</span> NbMaxConstrs);
<a name="l00103"></a>00103 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a1a9b9a572ee65d1c15aea3f9885dde7a">SubConstraint</a>(Value *Con,<a class="code" href="structpolyhedron.html">Polyhedron</a> *Pol,
<a name="l00104"></a>00104                                  <span class="keywordtype">unsigned</span> NbMaxRays, <span class="keywordtype">int</span> Pass);
<a name="l00105"></a>00105 <span class="keyword">extern</span> <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="polyhedron_8c.html#a832c074e0ce9da3df126dc7d51248276">Universe_Polyhedron</a> (<span class="keywordtype">unsigned</span> Dimension);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="preprocessor">#if defined(__cplusplus)</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>}
<a name="l00109"></a>00109 <span class="preprocessor">#endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111 <span class="preprocessor">#endif </span><span class="comment">/* _polyhedron_H_ */</span>
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
